/* CS5 - Channel Services src/parse.c
 * Copyright (c) 1998 Chris Birch <cs5@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> CS4.0
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include <bot.h>

void parse(char *line)
{
   int i = 0;
   char *sample = NULL, *nline = NULL, *cmd = NULL, *rest = NULL, *rest2 = NULL, *who = NULL, test[1000], ntest[1000], *tmsg = NULL, *test2 = NULL, *test3 = NULL, *test4 = NULL, *test5 = NULL, *nwnk = NULL, *nwts = NULL, *server = NULL, *botnum, *who2;
   char *samp1 = NULL, *samp2 = NULL, *samp3 = NULL, *samp4 = NULL, *samp5 = NULL, *samp6 = NULL, *ptr = NULL, *ptr1 = NULL, *ptr2 = NULL, *ptr3 = NULL, nrest[10000], logit[10000];
   char *nwho = NULL;
   int nick_server = 0;
   int auth_server = 1;

   trailing_blanks(line);
   
   if(strlen(line) > 524)
   {
       return;
   }
   
   strcpy(test, line);
   strcpy(ntest, line);

   if(*line ==  ':')
   {	 
	     if(who = strchr(line, ':')) *who++ = '\0';
		 if(cmd = strchr(who, ' '))  *cmd++ = '\0';
		 if(rest = strchr(cmd, ' ')) *rest++ = '\0';
		 if(!rest) rest = "NONE";
			

		 /* changement de nick */

		 if(!strncmp(cmd, "NICK", 4)) {
			if(test3 = strchr(rest, ' ')) *test3++ = '\0';
		    nwho = nick2num(who);
		    replace_node(nwho, rest);
		    return;
		 }

	   #ifdef DEBUG
	   printf("Line :[%s]\n", ntest);
	   #endif

         if(strcmp(cmd, "ACTION") && strcmp(cmd, "AWAY") && *rest == '#' && !strcmp(cmd, "PRIVMSG"))
         {
			if(samp1 = strchr(ntest, ' ')) *samp1++ = '\0';
			if(rest = strchr(samp1, ' ')) *rest++;
            if(ptr = strchr(samp1, ':')) *ptr++ = '\0';
			cmd = "PRIVMSG";

			if(*ptr == comchar)
            {
               *ptr++;

			   if(ptr1 = strchr(ptr, ' ')) *ptr1++ = '\0';

               for(i = 0; *commands[i].name; i++) 
               {
                  if(!strcasecmp(ptr, commands[i].name) && commands[i].secure && ptr1 == NULL) 
                  {
                     strlwr(ptr);
                     do_help(who, ptr);
                     return;
                  }
                  if(!strcasecmp(ptr, commands[i].name) && commands[i].secure && ptr1 != NULL) 
                  {
                     nwho = nick2num(who);
                     send_to_server(":%s NOTICE %s : Security Violation - Possible open display of password\n", bot.nick, who);
                     send_to_server(":%s NOTICE %s : Please use private message to %s when using passwords\n", bot.nick, who, bot.nick);
                     return;
                  }
                  if(!strcasecmp(ptr, commands[i].name) && commands[i].nochan) 
                  {
                     if(ptr1 != NULL)
                        sprintf(nrest, "%s :%s %s", bot.nick, ptr, ptr1);
                     else
                        sprintf(nrest, "%s :%s", bot.nick, ptr);
                     rest = nrest;
                  }
                  else if(!strcasecmp(ptr, commands[i].name) && !commands[i].nochan) 
                  {
                     if(ptr1 != NULL)
                     {
                        if(ptr1[0] == '#')
                           sprintf(nrest, "%s :%s %s", bot.nick, ptr, ptr1);
                        else
                           sprintf(nrest, "%s :%s %s%s", bot.nick, ptr, rest, ptr1);

                     }
                     else
                        sprintf(nrest, "%s :%s %s", bot.nick, ptr, rest);
                     rest = nrest;
                  }
                }
   
				   if(!strcmp(who, "PRIVMSG") && strstr(rest, botnum) && logging)
				 { 	

					  sprintf(logit, ":%s %s %s\n", who, cmd, rest);
						  log(BOT_LOG, "R [%s] %s",date(), logit);
				 }
           
			}
		    else return;
          } 
		  
     } else 
	    if(*line) {
		        if(who = strchr(line, ' '))  *who++ = '\0';
		        cmd = line;
		        if(rest = strchr(who, ' ')) *rest++ = '\0'; 
		        else rest = "NONE";
       } else return;

#ifdef DEBUG
printf("Parse - Command: [%s] Who: [%s] Rest: [%s]\n", cmd, who, rest);  
   if(msglog)
   {
      if(strcmp(cmd,"PONG") && strcmp(cmd, "PRIVMSG"))
      {
         command_log(who, cmd, rest);
      }
   }
#endif

   for(i = 0; parse_command[i].name; i++) 
   {       
	  if(!strcmp(cmd, parse_command[i].name)) 
      {
         parse_command[i].function(who, rest);
         return;
      }
   }
}
