/* CS5 - Channel Services src/parse_nick.c
 * Copyright (c) 1998 Chris Birch <cs5@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> CS4.0
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include <bot.h>

void parse_nick(char *who, char *rest)
{
   struct nickinfo *current;
   int i = 0, is_ops=0, got_i = 0, got_w = 0, got_both = 0;
   char *waste = NULL, *umode= NULL, *user = NULL, *host = NULL, *ptr = NULL, *ptrServ = NULL, *jtime = NULL, *reason = NULL, *what = NULL, *server = NULL, srv, *nwho = NULL, *num = NULL;
	
		/*
		who :bot
	    rest :2 1063877441 +i bot bot.com Services.E-ternet.com 0 :bot
	*/
   if(who)
   { 
      if(jtime = strchr(rest, ' ')) *jtime++ = '\0';
      if(umode = strchr(jtime, ' ')) *umode++ = '\0';
      if(user = strchr(umode, ' ')) *user++ = '\0';
      if(host = strchr(user, ' ')) *host++ = '\0';
      if(ptr = strchr(host, ' ')) *ptr++ = '\0';
	  if(ptrServ= strchr(ptr, ' ')) *ptrServ++ = '\0';
	  if(reason = strchr(ptrServ, ':')) *reason++ ='\0';
	  num = makenum(who);

	  if(umode)
      {
		  server = ptr;
		  #ifdef DEBUG
		  printf("add_nickinfo who %s, user %s, host %s, server %s, reason %s \n", who, user, host, server, reason);
		  printf("add_nickinfo-2 umode: %s, num : %s\n", umode, num);
		  #endif

         add_nickinfo(who, user, host, num, server, reason);
         if (strchr(umode,'+'))
         {
            current = nickhead;
            while(current != NULL)
            {
              if(!strcasecmp(who,current->nick))
              {
                 if(strchr(umode, 'o'))
                    current->is_oper=TRUE;
                 else 
                    current->is_oper=FALSE;
                 if(strchr(umode, 'i'))
                    got_i = 1;
                 if(strchr(umode, 'w'))
                    got_w = 1;
                 if(got_i && got_w)
                 {
                   strcpy(current->modes, "iw");
                   break;
                 }
                 if(got_i)
                   strcpy(current->modes, "i");
                 if(got_w)
                   strcpy(current->modes, "w");
              }
              current = current->next;
            }
         }
      }
      else
      { 
		 server = ptr;
		 #ifdef DEBUG
		 printf("add_nickinfo rest %s, user %s, host %s, server %s, reason %s \n", rest, user, host, server, reason);
         #endif
		 add_nickinfo(who, user, host, num, server, reason);
      }
   }
}
