/* CS5 - Channel Services src/num_tools.c
 * Copyright (c) 1998 Chris Birch <cs5@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> CS4.0
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

char *makenum(char *digest)
	{
		char *p,*crypted, *final;
		char num[11];
		int i,j,k;
		
		memset(num,0,sizeof(num));
		strncpy(num,digest,sizeof(num));
		j = 0;
		for(i=5;i<strlen(digest);i++) {
		  num[j] ^= digest[i];
		  j++;
		  j &= 0x7;
		}

		crypted = (char *)crypt(num,digest);
		crypted += 2;
		
		while((p = strstr(crypted,".")) != NULL) {
			*p = 'I';
		}
		
		while((p = strstr(crypted,"/")) != NULL) {
			*p = 'J';
		}
	    
		while((p = strstr(crypted,"0")) != NULL) {
			*p = 'K';
		}

        while((p = strstr(crypted,"5")) != NULL) {
			*p = 'L';
		}
		
		
		return crypted;
	}

void serv_unused(char *server)
{
   int i;
      if(!strcasecmp(server,servinfo[i].server))
      {
         servinfo[i].used = FALSE;
         return;
      }
}

void serv_used(char chars, char *server)
{
   int i;

      if(chars == servinfo[i].chars)
      {
         servinfo[i].used = TRUE;
         strcpy(servinfo[i].server, server);
         return;
      }
}


char *num2serv(char *num)
{
  return num;
}

char *nick2num(char *who)
{
  struct nickinfo *current;

   current = nickhead;
  while(current != NULL)
  {
     if(!strcasecmp(who, current->nick))
     {
        return(current->numeric);
     }
     current=current->next;
   }
   return NULL; 
}

char *num2nick(char *nwnick)
{
  struct nickinfo *current;

  current = nickhead;

  while(current != NULL)
  {
     if(!strcmp(nwnick, current->numeric))
     {
        return(current->nick);
     }
     current=current->next;
   }
   return NULL; 
}
